#pragma once
#include "pipe.h"
#include <armadillo>
using namespace std;
using namespace arma;

class Pipe;

class node{
	public:
	int index; 
	double pressure; //pressure in each node
	bool upper; // bool indicating if the vertical tube is pointing up or down
	int n; //horizontal position in network
	int m; //vertical position in network
	double x; // x-coordinate
	double y; // y-coordinate
	Pipe* leftPipe; 
	Pipe* rightPipe;
	Pipe* verticalPipe;
	node* leftNode;
	node* rightNode;
	node* verticalNode;
	double nodeFluxTL; //Total node flux
	double nodeFluxNW; 
	double nodeFrac;
	void setConnections(Pipe pipes[],node nodes[],int N,int M);
	void updateNodeFrac();
	void bubbleAdjust(Pipe* pipes);
};
