#pragma once
#include <armadillo>
#include "node.h"
#define maxBubbles 15
using namespace std;
using namespace arma;
extern double sTens, PI, muNON, muWET;

class node;

enum RadiusFunc {OLD, UNREAL, REAL};
enum TubeType {CIRC, TRIAG1, TRIAG2}; //Triag1 equilateral triangle Triag2 narrow triangle

class Pipe{
	public:
	bool swapped = false;
	int index;
	int nBubbles=0;
	double x1 = -1;
	double x2 = -1;
	double y1 = -1;
	double y2 = -1;
	double radius;
	double Pc;
	double flow;
	double area;
	double length = 1;
	double lenTL;
	double lenNW;
	double G;
	double saturation;
	bool boundary;
	double* bubbleStart;
	double* bubbleStop;
	double mobility;
	double theta = 0;
	double x_t_start;
	double x_t_stop;
	node* nodeP;
	node* nodeN;
	void setCoordinates(double x, double y);
	void moveBubble(double dt);
	void distributeBubbles();
	void Swap();
	void killBubbles();
	void getFlow(double pressure);
	void getCapBoundaries();
	double PcStart(double pos,double theta, double muEff);
	double PcStop(double pos,double theta, double muEff);
	double calcLinkSaturation();
	void calcPcandMobility();
	Pipe();
};
